diff --git a/Documentation/devicetree/bindings/arm/qcom.yaml b/Documentation/devicetree/bindings/arm/qcom.yaml
index 5c06d1bfc046..399be67eb5d2 100644
--- a/Documentation/devicetree/bindings/arm/qcom.yaml
+++ b/Documentation/devicetree/bindings/arm/qcom.yaml
@@ -214,11 +214,191 @@ properties:
               - qcom,ipq8074-hk10-c2
           - const: qcom,ipq8074
 
+      # Qualcomm Technologies, Inc. SC7180 IDP
       - items:
           - enum:
               - qcom,sc7180-idp
           - const: qcom,sc7180
 
+      # Google CoachZ (rev1 - 2)
+      - items:
+          - const: google,coachz-rev1
+          - const: google,coachz-rev2
+          - const: qcom,sc7180
+
+      # Google CoachZ (newest rev)
+      - items:
+          - const: google,coachz
+          - const: qcom,sc7180
+
+      # Google CoachZ with LTE (rev1 - 2)
+      - items:
+          - const: google,coachz-rev1-sku0
+          - const: google,coachz-rev2-sku0
+          - const: qcom,sc7180
+
+      # Google CoachZ with LTE (newest rev)
+      - items:
+          - const: google,coachz-sku0
+          - const: qcom,sc7180
+
+      # Google Homestar (rev2)
+      - items:
+          - const: google,homestar-rev2
+          - const: google,homestar-rev23
+          - const: qcom,sc7180
+
+      # Google Homestar (rev3)
+      - items:
+          - const: google,homestar-rev3
+          - const: qcom,sc7180
+
+      # Google Homestar (newest rev)
+      - items:
+          - const: google,homestar
+          - const: qcom,sc7180
+
+      # Google Lazor (rev0)
+      - items:
+          - const: google,lazor-rev0
+          - const: qcom,sc7180
+
+      # Google Lazor (rev1 - 2)
+      - items:
+          - const: google,lazor-rev1
+          - const: google,lazor-rev2
+          - const: qcom,sc7180
+
+      # Google Lazor (rev3 - 8)
+      - items:
+          - const: google,lazor-rev3
+          - const: google,lazor-rev4
+          - const: google,lazor-rev5
+          - const: google,lazor-rev6
+          - const: google,lazor-rev7
+          - const: google,lazor-rev8
+          - const: qcom,sc7180
+
+      # Google Lazor (newest rev)
+      - items:
+          - const: google,lazor
+          - const: qcom,sc7180
+
+      # Google Lazor with KB Backlight (rev1 - 2)
+      - items:
+          - const: google,lazor-rev1-sku2
+          - const: google,lazor-rev2-sku2
+          - const: qcom,sc7180
+
+      # Google Lazor with KB Backlight (rev3 - 8)
+      - items:
+          - const: google,lazor-rev3-sku2
+          - const: google,lazor-rev4-sku2
+          - const: google,lazor-rev5-sku2
+          - const: google,lazor-rev6-sku2
+          - const: google,lazor-rev7-sku2
+          - const: google,lazor-rev8-sku2
+          - const: qcom,sc7180
+
+      # Google Lazor with KB Backlight (newest rev)
+      - items:
+          - const: google,lazor-sku2
+          - const: qcom,sc7180
+
+      # Google Lazor with LTE (rev1 - 2)
+      - items:
+          - const: google,lazor-rev1-sku0
+          - const: google,lazor-rev2-sku0
+          - const: qcom,sc7180
+
+      # Google Lazor with LTE (rev3 - 8)
+      - items:
+          - const: google,lazor-rev3-sku0
+          - const: google,lazor-rev4-sku0
+          - const: google,lazor-rev5-sku0
+          - const: google,lazor-rev6-sku0
+          - const: google,lazor-rev7-sku0
+          - const: google,lazor-rev8-sku0
+          - const: qcom,sc7180
+
+      # Google Lazor with LTE (newest rev)
+      - items:
+          - const: google,lazor-sku0
+          - const: qcom,sc7180
+
+      # Google Lazor Limozeen (rev4 - rev8)
+      - items:
+          - const: google,lazor-rev4-sku4
+          - const: google,lazor-rev5-sku4
+          - const: google,lazor-rev6-sku4
+          - const: google,lazor-rev7-sku4
+          - const: google,lazor-rev8-sku4
+          - const: qcom,sc7180
+
+      # Google Lazor Limozeen (newest rev)
+      - items:
+          - const: google,lazor-sku4
+          - const: qcom,sc7180
+
+      # Google Lazor Limozeen without Touchscreen (rev4)
+      - items:
+          - const: google,lazor-rev4-sku5
+          - const: qcom,sc7180
+
+      # Google Lazor Limozeen without Touchscreen (rev5 - rev8)
+      - items:
+          - const: google,lazor-rev5-sku5
+          - const: google,lazor-rev5-sku6
+          - const: google,lazor-rev6-sku6
+          - const: google,lazor-rev7-sku6
+          - const: google,lazor-rev8-sku6
+          - const: qcom,sc7180
+
+      # Google Lazor Limozeen without Touchscreen (newest rev)
+      - items:
+          - const: google,lazor-sku6
+          - const: qcom,sc7180
+
+      # Google Pompom (rev1)
+      - items:
+          - const: google,pompom-rev1
+          - const: qcom,sc7180
+
+      # Google Pompom (rev2)
+      - items:
+          - const: google,pompom-rev2
+          - const: qcom,sc7180
+
+      # Google Pompom (newest rev)
+      - items:
+          - const: google,pompom
+          - const: qcom,sc7180
+
+      # Google Pompom with LTE (rev1)
+      - items:
+          - const: google,pompom-rev1-sku0
+          - const: qcom,sc7180
+
+      # Google Pompom with LTE (rev2)
+      - items:
+          - const: google,pompom-rev2-sku0
+          - const: qcom,sc7180
+
+      # Google Pompom with LTE (newest rev)
+      - items:
+          - const: google,pompom-sku0
+          - const: qcom,sc7180
+
+      # Google Trogdor (newest rev)
+      - items:
+          - const: google,trogdor
+          - const: qcom,sc7180
+
+      # Google Trogdor (newest rev) with LTE
+      - items:
+          - const: google,trogdor-sku0
+          - const: qcom,sc7180
+
       - items:
           - enum:
               - qcom,sc7280-crd